/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2020, Arnaud Roques
 *
 * Project Info:  https://plantuml.com
 * 
 * If you like this project or if you find it useful, you can support us at:
 * 
 * https://plantuml.com/patreon (only 1$ per month!)
 * https://plantuml.com/paypal
 * 
 * This file is part of PlantUML.
 *
 * PlantUML is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * PlantUML distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 *
 * Original Author:  Arnaud Roques
 */
package ext.plantuml.com.ctreber.acearth.plugins;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import ext.plantuml.com.ctreber.acearth.ACearth;
import ext.plantuml.com.ctreber.acearth.gui.PixelCanvas;
import ext.plantuml.com.ctreber.acearth.projection.Projection;

/**
 * <p></p>
 *
 * <p>&copy; 2002 Christian Treber, ct@ctreber.com (Nov 6, 2002)</p>
 * @author Christian Treber, ct@ctreber.com
 *
 */
abstract public class Plugin implements ActionListener
{
  protected ACearth fParent;
  protected boolean fActiveP = true;
  protected Projection fProjection;
  protected PixelCanvas fRenderTarget;

  public void actionPerformed(ActionEvent e)
  {
  }

  abstract public boolean hasGUIP();

  abstract public void render();

  public void setProjection(Projection pProjection)
  {
    fProjection = pProjection;
  }

  public void setRenderTarget(PixelCanvas pRenderTarget)
  {
    fRenderTarget = pRenderTarget;
  }

  public void setParent(ACearth pParent)
  {
    fParent = pParent;
  }
}
