/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2020, Arnaud Roques
 *
 * Project Info:  https://plantuml.com
 * 
 * If you like this project or if you find it useful, you can support us at:
 * 
 * https://plantuml.com/patreon (only 1$ per month!)
 * https://plantuml.com/paypal
 * 
 * This file is part of PlantUML.
 *
 * PlantUML is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * PlantUML distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 *
 * Original Author:  Arnaud Roques
 */
package ext.plantuml.com.ctreber.acearth.plugins.markers;

import java.util.Iterator;
import java.util.List;

import ext.plantuml.com.ctreber.acearth.plugins.Plugin;

/**
 * <p>
 * Renders markers to the render target. a
 * <p>
 * &copy; 2002 Christian Treber, ct@ctreber.com
 * 
 * @author Christian Treber, ct@ctreber.com
 * 
 */
public class PluginMarkers extends Plugin {
	private List fMarkers;

	// private String fMarkerFileName = ACearth.getHomeDir() +
	// "markersDefault.txt";

	public PluginMarkers(List<Marker> markers) {
		// ACearth.indent("AC.earth Markers plug-in");
		//
		// ACearth.log("Reading markers");
		//
		// if(fMarkerFileName == null)
		// {
		// throw new RuntimeException("Marker file name not set");
		// }

		// try
		// {
		// fMarkers = Marker.loadMarkerFile(fMarkerFileName);
		// } catch(IOException e)
		// {
		// ACearth.logError("Marker file not found");
		// return;
		// }
		
		fMarkers = markers;

		// ACearth.outdent();
	}

	public boolean hasGUIP() {
		return false;
	}

	public void render() {
		if (!fActiveP) {
			return;
		}

		// fRenderTarget.setTextFont(fRenderTarget.getTextFont().deriveFont(9.0f));
		Iterator lIt = fMarkers.iterator();
		while (lIt.hasNext()) {
			Marker lMarker = (Marker) lIt.next();
			lMarker.render(fRenderTarget, fProjection);
		}
	}

	// public void setMarkerFileName(String pMarkerFileName)
	// {
	// fMarkerFileName = pMarkerFileName;
	// }

	public String toString() {
		return "AC.earth Markers plug-in";
	}
}
