/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2020, Arnaud Roques
 *
 * Project Info:  https://plantuml.com
 * 
 * If you like this project or if you find it useful, you can support us at:
 * 
 * https://plantuml.com/patreon (only 1$ per month!)
 * https://plantuml.com/paypal
 * 
 * This file is part of PlantUML.
 *
 * PlantUML is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * PlantUML distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 *
 * Original Author:  Arnaud Roques
 */
package ext.plantuml.com.ctreber.acearth.scanbit;

/**
 * <p>Instruction to paint points xFrom to xTo on line y.
 *
 * <p>What I don't understand: why do values get summed to determine the
 * pixel type?
 *
 * <p>&copy; 2002 Christian Treber, ct@ctreber.com
 * @author Christian Treber, ct@ctreber.com
 *
 */
public class ScanBit implements Comparable
{
  private int fY;
  private int lXFrom;
  private int fXTo;
  private int fType;

  public ScanBit(int pY, int pLoX, int pHiX, int pType)
  {
    fY = pY;
    lXFrom = pLoX;
    fXTo = pHiX;
    fType = pType;
  }

  public int compareTo(Object o)
  {
    if(o instanceof ScanBit)
    {
      ScanBit lOther = (ScanBit)o;
      return (fY > lOther.fY) ? 1 : (fY < lOther.fY) ? -1 : 0;
    }

    throw new IllegalArgumentException("Can't compare with " + o.getClass());
  }

  public int getY()
  {
    return fY;
  }

  public int getlXFrom()
  {
    return lXFrom;
  }

  public int getXTo()
  {
    return fXTo;
  }

  /**
   * <p>See values for
   * @see ext.plantuml.com.ctreber.acearth.util.Polygon
   */
  public int getType()
  {
    return fType;
  }
}
