/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2020, Arnaud Roques
 *
 * Project Info:  https://plantuml.com
 * 
 * If you like this project or if you find it useful, you can support us at:
 * 
 * https://plantuml.com/patreon (only 1$ per month!)
 * https://plantuml.com/paypal
 * 
 * This file is part of PlantUML.
 *
 * PlantUML is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * PlantUML distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 *
 * Original Author:  Arnaud Roques
 */
package ext.plantuml.com.ctreber.acearth.util;

/**
 * <p>Holds information about a line crossing "the edge of Earth".
 *
 * <p>&copy; 2002 Christian Treber, ct@ctreber.com
 * @author Christian Treber, ct@ctreber.com
 *
 */
public class EdgeCrossing
{
  public static final int XingTypeEntry = 0;
  public static final int XingTypeExit = 1;

  private int fType;
  private int fIndex;
  private double fX;
  private double fY;
  private double fAngle;

  public EdgeCrossing(int pType, int pIndex, double pX, double pY, double pAngle)
  {
    fType = pType;
    fX = pX;
    fY = pY;
    fAngle = pAngle;
    fIndex = pIndex;
  }

  public String toString()
  {
    return fType + ": " + fX + ", " + fY + ", " + fAngle + " (" + fIndex + ")";
  }

  public int getType()
  {
    return fType;
  }

  public double getX()
  {
    return fX;
  }

  public double getY()
  {
    return fY;
  }

  public double getAngle()
  {
    return fAngle;
  }

  public int getIndex()
  {
    return fIndex;
  }
}
